document.querySelectorAll(".share").forEach((element) => {
  if (navigator.share) {
    element.classList.add("active");
  }
  element.addEventListener("click", (e) => {
    let share_data = {
      url: document.getElementById(element.dataset.share_url_target).value,
      title: element.dataset.share_title,
    };
    navigator.share(share_data).catch((reason) => {
      console.error(reason);
    });
  });
});

document.querySelectorAll(".copy").forEach((element) => {
  element.classList.add("active");
  element.addEventListener("click", event => {
    event.preventDefault();
    let target = document.getElementById(element.dataset.target);
    target.focus();
    target.setSelectionRange(0, target.value.length);
    navigator.clipboard.writeText(target.value).then(() => {
      element.classList.add("success");
      setTimeout(() => {
        element.classList.remove("success");
      }, 1000);
    });
  });
});

document.querySelectorAll(".js-only").forEach((element) => {
  element.classList.remove("js-only");
});